Module javafx.graphics
Package javafx.scene.shape

## Class Line

- java.lang.Object
- - javafx.scene.Node
  - - javafx.scene.shape.Shape
    - - javafx.scene.shape.Line

- All Implemented Interfaces:
    `Styleable`, `EventTarget`

      public class Line
      extends Shape

  This Line represents a line segment in `(x,y)` coordinate space. Example:

      import javafx.scene.shape.*;

      Line line = new Line();
      line.setStartX(0.0f);
      line.setStartY(0.0f);
      line.setEndX(100.0f);
      line.setEndY(100.0f);
      }

  Since:
    JavaFX 2.0

- - ### Property Summary

    Properties
    Type | Property | Description
    --- | --- | ---
    `DoubleProperty` | `endX` | The X coordinate of the end point of the line segment.
    `DoubleProperty` | `endY` | The Y coordinate of the end point of the line segment.
    `DoubleProperty` | `startX` | The X coordinate of the start point of the line segment.
    `DoubleProperty` | `startY` | The Y coordinate of the start point of the line segment.

    - ### Properties inherited from class javafx.scene.shape.Shape

      `fill, smooth, strokeDashOffset, strokeLineCap, strokeLineJoin, strokeMiterLimit, stroke, strokeType, strokeWidth`

    - ### Properties inherited from class javafx.scene.Node

      `accessibleHelp, accessibleRoleDescription, accessibleRole, accessibleText, blendMode, boundsInLocal, boundsInParent, cacheHint, cache, clip, cursor, depthTest, disabled, disable, effectiveNodeOrientation, effect, eventDispatcher, focused, focusTraversable, hover, id, inputMethodRequests, layoutBounds, layoutX, layoutY, localToParentTransform, localToSceneTransform, managed, mouseTransparent, nodeOrientation, onContextMenuRequested, onDragDetected, onDragDone, onDragDropped, onDragEntered, onDragExited, onDragOver, onInputMethodTextChanged, onKeyPressed, onKeyReleased, onKeyTyped, onMouseClicked, onMouseDragEntered, onMouseDragExited, onMouseDragged, onMouseDragOver, onMouseDragReleased, onMouseEntered, onMouseExited, onMouseMoved, onMousePressed, onMouseReleased, onRotate, onRotationFinished, onRotationStarted, onScrollFinished, onScroll, onScrollStarted, onSwipeDown, onSwipeLeft, onSwipeRight, onSwipeUp, onTouchMoved, onTouchPressed, onTouchReleased, onTouchStationary, onZoomFinished, onZoom, onZoomStarted, opacity, parent, pickOnBounds, pressed, rotate, rotationAxis, scaleX, scaleY, scaleZ, scene, style, translateX, translateY, translateZ, viewOrder, visible`

  - ### Field Summary

    - ### Fields inherited from class javafx.scene.Node

      `BASELINE_OFFSET_SAME_AS_HEIGHT`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Line()` | Creates an empty instance of Line.
    `Line​(double startX, double startY, double endX, double endY)` | Creates a new instance of Line.

  - ### Method Summary

    Modifier and Type | Method | Description
    --- | --- | ---
    `DoubleProperty` | `endXProperty()` | The X coordinate of the end point of the line segment.
    `DoubleProperty` | `endYProperty()` | The Y coordinate of the end point of the line segment.
    `double` | `getEndX()` | Gets the value of the property endX.
    `double` | `getEndY()` | Gets the value of the property endY.
    `double` | `getStartX()` | Gets the value of the property startX.
    `double` | `getStartY()` | Gets the value of the property startY.
    `void` | `setEndX​(double value)` | Sets the value of the property endX.
    `void` | `setEndY​(double value)` | Sets the value of the property endY.
    `void` | `setStartX​(double value)` | Sets the value of the property startX.
    `void` | `setStartY​(double value)` | Sets the value of the property startY.
    `DoubleProperty` | `startXProperty()` | The X coordinate of the start point of the line segment.
    `DoubleProperty` | `startYProperty()` | The Y coordinate of the start point of the line segment.
    `String` | `toString()` | Returns a string representation of this `Line` object.

    - ### Methods inherited from class javafx.scene.shape.Shape

      `fillProperty, getClassCssMetaData, getCssMetaData, getFill, getStroke, getStrokeDashArray, getStrokeDashOffset, getStrokeLineCap, getStrokeLineJoin, getStrokeMiterLimit, getStrokeType, getStrokeWidth, intersect, isSmooth, setFill, setSmooth, setStroke, setStrokeDashOffset, setStrokeLineCap, setStrokeLineJoin, setStrokeMiterLimit, setStrokeType, setStrokeWidth, smoothProperty, strokeDashOffsetProperty, strokeLineCapProperty, strokeLineJoinProperty, strokeMiterLimitProperty, strokeProperty, strokeTypeProperty, strokeWidthProperty, subtract, union`

    - ### Methods inherited from class javafx.scene.Node

      `accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, executeAccessibleAction, fireEvent, focusedProperty, focusTraversableProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBaselineOffset, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClip, getContentBias, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInitialFocusTraversable, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isResizable, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookup, lookupAll, managedProperty, maxHeight, maxWidth, minHeight, minWidth, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, prefHeight, prefWidth, pressedProperty, pseudoClassStateChanged, queryAccessibleAttribute, relocate, removeEventFilter, removeEventHandler, requestFocus, resize, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface javafx.css.Styleable

      `getStyleableNode`

- - ### Property Detail

    - #### startX

          public final DoubleProperty startXProperty

      The X coordinate of the start point of the line segment.
      Default value:
        0.0
      See Also:
        `getStartX()`, `setStartX(double)`

    - #### startY

          public final DoubleProperty startYProperty

      The Y coordinate of the start point of the line segment.
      Default value:
        0.0
      See Also:
        `getStartY()`, `setStartY(double)`

    - #### endX

          public final DoubleProperty endXProperty

      The X coordinate of the end point of the line segment.
      Default value:
        0.0
      See Also:
        `getEndX()`, `setEndX(double)`

    - #### endY

          public final DoubleProperty endYProperty

      The Y coordinate of the end point of the line segment.
      Default value:
        0.0
      See Also:
        `getEndY()`, `setEndY(double)`

  - ### Constructor Detail

    - #### Line

          public Line()

      Creates an empty instance of Line.

    - #### Line

          public Line​(double startX,
                      double startY,
                      double endX,
                      double endY)

      Creates a new instance of Line.
      Parameters:
        `startX` - the horizontal coordinate of the start point of the line segment
        `startY` - the vertical coordinate of the start point of the line segment
        `endX` - the horizontal coordinate of the end point of the line segment
        `endY` - the vertical coordinate of the end point of the line segment

  - ### Method Detail

    - #### setStartX

          public final void setStartX​(double value)

      Sets the value of the property startX.
      Property description:
        The X coordinate of the start point of the line segment.
      Default value:
        0.0

    - #### getStartX

          public final double getStartX()

      Gets the value of the property startX.
      Property description:
        The X coordinate of the start point of the line segment.
      Default value:
        0.0

    - #### startXProperty

          public final DoubleProperty startXProperty()

      The X coordinate of the start point of the line segment.
      Default value:
        0.0
      See Also:
        `getStartX()`, `setStartX(double)`

    - #### setStartY

          public final void setStartY​(double value)

      Sets the value of the property startY.
      Property description:
        The Y coordinate of the start point of the line segment.
      Default value:
        0.0

    - #### getStartY

          public final double getStartY()

      Gets the value of the property startY.
      Property description:
        The Y coordinate of the start point of the line segment.
      Default value:
        0.0

    - #### startYProperty

          public final DoubleProperty startYProperty()

      The Y coordinate of the start point of the line segment.
      Default value:
        0.0
      See Also:
        `getStartY()`, `setStartY(double)`

    - #### setEndX

          public final void setEndX​(double value)

      Sets the value of the property endX.
      Property description:
        The X coordinate of the end point of the line segment.
      Default value:
        0.0

    - #### getEndX

          public final double getEndX()

      Gets the value of the property endX.
      Property description:
        The X coordinate of the end point of the line segment.
      Default value:
        0.0

    - #### endXProperty

          public final DoubleProperty endXProperty()

      The X coordinate of the end point of the line segment.
      Default value:
        0.0
      See Also:
        `getEndX()`, `setEndX(double)`

    - #### setEndY

          public final void setEndY​(double value)

      Sets the value of the property endY.
      Property description:
        The Y coordinate of the end point of the line segment.
      Default value:
        0.0

    - #### getEndY

          public final double getEndY()

      Gets the value of the property endY.
      Property description:
        The Y coordinate of the end point of the line segment.
      Default value:
        0.0

    - #### endYProperty

          public final DoubleProperty endYProperty()

      The Y coordinate of the end point of the line segment.
      Default value:
        0.0
      See Also:
        `getEndY()`, `setEndY(double)`

    - #### toString

          public String toString()

      Returns a string representation of this `Line` object.
      Overrides:
        `toString` in class `Node`
      Returns:
        a string representation of this `Line` object.